/* 	

		Averaging routine averages() of Arvert 4.x
		P. Zeitler, Lehigh University
		2/19/04
		
		averages() determines average and bracketing thermal history and average age spectrum
  	
*/

#include "arvert.h"

void averages(double **poolAge, double **poolTemp)
{

	extern double avTemp[nodes], avAge[101], lowEnvelope[nodes], highEnvelope[nodes];
	extern long poolsize, labsteps;
	extern long ttpoints;
	extern double avHeage;
	extern double Hepool[302];
	extern long useHelium;

	long i, j;
	
	for (i = 1; i <= ttpoints; i++)
	{
		lowEnvelope[i] = 1000;
		highEnvelope[i] = -100;
		avTemp[i] = poolTemp[1][i];
		for (j = 2; j <= poolsize; j++)
		{
			avTemp[i] = avTemp[i] + poolTemp[j][i];
			if (lowEnvelope[i] > poolTemp[j][i])
			{
				lowEnvelope[i] = poolTemp[j][i];
			}
			if (highEnvelope[i] < poolTemp[j][i])
			{
				highEnvelope[i] = poolTemp[j][i];
			}
		}
		avTemp[i] = avTemp[i]/(poolsize);
	}

	for (i = 1; i <= labsteps; i++)
	{
		avAge[i] = 0.0;
		for (j = 1; j <= poolsize; j++)
		{
			avAge[i] = avAge[i] + poolAge[j][i];
		}
		avAge[i] = avAge[i]/(poolsize);
	}
	if (useHelium == 1)
	{
		avHeage = Hepool[1];
		for (i = 2; i <= poolsize; i++)
		{
			avHeage = avHeage + Hepool[i];
		}
		avHeage = avHeage/poolsize;
	}

	return;
}