/* 	

		Functions selectsubset() and randomselect() of Arvert 4.x
		P. Zeitler, Lehigh University
		8/6/00
		
		The former is a key routine for constrained-random-search algorithm. Selects
		a random subset of thermal histories from the main pool of histories. The
		selected histories are unique--there is no duplication of the selections.
		
		Function randomselect() just picks a random number in a range equivalent to the
		number of histories in the pool.
	
*/

#include "arvert.h"

// ------- Function selectsubset() -------------------------

void selectsubset(void)
{
	extern long subsetsize, CRS_selection, CRSselections[302];

	long i,j,duplicate;

	CRSselections[1] = randomselect();
	for (i = 2; i <= subsetsize + 1; i++)
	{
		do
		{
			CRSselections[i] = randomselect();
			duplicate = 0;
			for (j = 1; j <= i - 1; j++)
			{
				if (CRSselections[i] == CRSselections[j])
				{
					duplicate = 1;
					break;
				}
			}
		}
		while (duplicate == 1);
	}
	
	CRS_selection = CRSselections[subsetsize + 1];  // index of history to be modified using CRS algorithm

	return;
}


// ------- Function randomselect() -------------------------

long randomselect(void)
{
	extern long poolsize, RanSeedZero;
	long selection;
	
	selection = poolsize + 1;
	while (selection > poolsize)  // guard against unlikely case that ran3() = 1, making selection i_carlos + 1
	{
		selection = 1 + floor(ran3(RanSeedZero) * (poolsize));
	}
	
	return selection;
}