/* 	

		Sorting functions sort() of Arvert 4.x
		P. Zeitler, Lehigh University
		2/04/01
		
		sort() arranges PoolAge, PoolTemp, Hepool, and ModelFit in order: best to worst fit
		
		4/04 -- added sorting of He data
  	
*/

#include "arvert.h"

void sort(double **poolAge, double **poolTemp, double **poolTime)
{

	extern double ModelFit[302];
	extern double Hepool[302];
	extern long poolsize, labsteps;
	extern long ttpoints;
	extern long useHelium;

	long i, j, k;
	double swap;
	
	for (i = 1; i <= poolsize - 1; i++)
	{
		for (j = i + 1; j <= poolsize; j ++)
		{
			if (ModelFit[j] < ModelFit[i])
			{
				// swap fit
				swap = ModelFit[i];
				ModelFit[i] = ModelFit[j];
				ModelFit[j] = swap;
				// swap all the He ages in the helium pool		
				if (useHelium == 1)
				{		
					swap = Hepool[i];
					Hepool[i] = Hepool[j];
					Hepool[j] = swap;
				}
				// swap all the spectra in the age-spectrum pool
				for (k = 1; k <= labsteps; k++)
				{
					swap = poolAge[i][k];
					poolAge[i][k] = poolAge[j][k];
					poolAge[j][k] = swap;
				}
				// swap all the temperature nodes in the history
				for (k = 1; k <= ttpoints; k++)
				{
					swap = poolTemp[i][k];
					poolTemp[i][k] = poolTemp[j][k];
					poolTemp[j][k] = swap;
				}
				// swap all the time nodes in the history
				for (k = 1; k <= ttpoints; k++)
				{
					swap = poolTime[i][k];
					poolTime[i][k] = poolTime[j][k];
					poolTime[j][k] = swap;
				}
			}
		}
	}
	
	return;
}